#import "AppInterface.h"

BOOL trapCutCopyPasteForDialog = NO;

@interface AppInterface()
@end

@implementation AppInterface

- (void)sendEvent:(NSEvent *)event
{
	if (trapCutCopyPasteForDialog && [event type] == NSEventTypeKeyDown)
	{
		if (([event modifierFlags] & NSEventModifierFlagDeviceIndependentFlagsMask) == NSEventModifierFlagCommand)
		{
			if ([[event charactersIgnoringModifiers] isEqualToString:@"x"])
			{
				if ([self sendAction:@selector(cut:) to:nil from:self])
					return;
			}
			else if ([[event charactersIgnoringModifiers] isEqualToString:@"c"])
			{
				if ([self sendAction:@selector(copy:) to:nil from:self])
					return;
			}
			else if ([[event charactersIgnoringModifiers] isEqualToString:@"v"])
			{
				if ([self sendAction:@selector(paste:) to:nil from:self])
					return;
			}
			else if ([[event charactersIgnoringModifiers] isEqualToString:@"z"])
			{
				if ([self sendAction:@selector(undo:) to:nil from:self])
					return;
			}
			else if ([[event charactersIgnoringModifiers] isEqualToString:@"a"])
			{
				if ([self sendAction:@selector(selectAll:) to:nil from:self])
					return;
			}
		}
		else if (([event modifierFlags] & NSEventModifierFlagDeviceIndependentFlagsMask) == (NSEventModifierFlagCommand | NSEventModifierFlagShift))
		{
			if ([[event charactersIgnoringModifiers] isEqualToString:@"Z"])
			{
				if ([self sendAction:@selector(redo:) to:nil from:self])
					return;
			}
		}
	}
	[super sendEvent:event];
}

@end
